<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/proc-macro2-1.0.42/src/detection.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>detection.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../proc_macro2/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../proc_macro2/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../proc_macro2/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::sync::atomic</span>::{<span class="ident">AtomicUsize</span>, <span class="ident">Ordering</span>};
<span class="kw">use</span> <span class="ident">std::sync::Once</span>;

<span class="kw">static</span> <span class="ident">WORKS</span>: <span class="ident">AtomicUsize</span> <span class="op">=</span> <span class="ident">AtomicUsize::new</span>(<span class="number">0</span>);
<span class="kw">static</span> <span class="ident">INIT</span>: <span class="ident">Once</span> <span class="op">=</span> <span class="ident">Once::new</span>();

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">inside_proc_macro</span>() -&gt; <span class="ident">bool</span> {
    <span class="kw">match</span> <span class="ident">WORKS</span>.<span class="ident">load</span>(<span class="ident">Ordering::Relaxed</span>) {
        <span class="number">1</span> =&gt; <span class="kw">return</span> <span class="bool-val">false</span>,
        <span class="number">2</span> =&gt; <span class="kw">return</span> <span class="bool-val">true</span>,
        <span class="kw">_</span> =&gt; {}
    }

    <span class="ident">INIT</span>.<span class="ident">call_once</span>(<span class="ident">initialize</span>);
    <span class="ident">inside_proc_macro</span>()
}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">force_fallback</span>() {
    <span class="ident">WORKS</span>.<span class="ident">store</span>(<span class="number">1</span>, <span class="ident">Ordering::Relaxed</span>);
}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">unforce_fallback</span>() {
    <span class="ident">initialize</span>();
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">no_is_available</span>))]</span>
<span class="kw">fn</span> <span class="ident">initialize</span>() {
    <span class="kw">let</span> <span class="ident">available</span> <span class="op">=</span> <span class="ident">proc_macro::is_available</span>();
    <span class="ident">WORKS</span>.<span class="ident">store</span>(<span class="ident">available</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">+</span> <span class="number">1</span>, <span class="ident">Ordering::Relaxed</span>);
}

<span class="comment">// Swap in a null panic hook to avoid printing &quot;thread panicked&quot; to stderr,</span>
<span class="comment">// then use catch_unwind to determine whether the compiler&#39;s proc_macro is</span>
<span class="comment">// working. When proc-macro2 is used from outside of a procedural macro all</span>
<span class="comment">// of the proc_macro crate&#39;s APIs currently panic.</span>
<span class="comment">//</span>
<span class="comment">// The Once is to prevent the possibility of this ordering:</span>
<span class="comment">//</span>
<span class="comment">//     thread 1 calls take_hook, gets the user&#39;s original hook</span>
<span class="comment">//     thread 1 calls set_hook with the null hook</span>
<span class="comment">//     thread 2 calls take_hook, thinks null hook is the original hook</span>
<span class="comment">//     thread 2 calls set_hook with the null hook</span>
<span class="comment">//     thread 1 calls set_hook with the actual original hook</span>
<span class="comment">//     thread 2 calls set_hook with what it thinks is the original hook</span>
<span class="comment">//</span>
<span class="comment">// in which the user&#39;s hook has been lost.</span>
<span class="comment">//</span>
<span class="comment">// There is still a race condition where a panic in a different thread can</span>
<span class="comment">// happen during the interval that the user&#39;s original panic hook is</span>
<span class="comment">// unregistered such that their hook is incorrectly not called. This is</span>
<span class="comment">// sufficiently unlikely and less bad than printing panic messages to stderr</span>
<span class="comment">// on correct use of this crate. Maybe there is a libstd feature request</span>
<span class="comment">// here. For now, if a user needs to guarantee that this failure mode does</span>
<span class="comment">// not occur, they need to call e.g. `proc_macro2::Span::call_site()` from</span>
<span class="comment">// the main thread before launching any other threads.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">no_is_available</span>)]</span>
<span class="kw">fn</span> <span class="ident">initialize</span>() {
    <span class="kw">use</span> <span class="ident">std::panic</span>::{<span class="self">self</span>, <span class="ident">PanicInfo</span>};

    <span class="kw">type</span> <span class="ident">PanicHook</span> <span class="op">=</span> <span class="kw">dyn</span> <span class="ident">Fn</span>(<span class="kw-2">&amp;</span><span class="ident">PanicInfo</span>) <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="lifetime">&#39;static</span>;

    <span class="kw">let</span> <span class="ident">null_hook</span>: <span class="ident">Box</span><span class="op">&lt;</span><span class="ident">PanicHook</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">Box::new</span>(<span class="op">|</span><span class="ident">_panic_info</span><span class="op">|</span> { <span class="comment">/* ignore */</span> });
    <span class="kw">let</span> <span class="ident">sanity_check</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="ident">null_hook</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">PanicHook</span>;
    <span class="kw">let</span> <span class="ident">original_hook</span> <span class="op">=</span> <span class="ident">panic::take_hook</span>();
    <span class="ident">panic::set_hook</span>(<span class="ident">null_hook</span>);

    <span class="kw">let</span> <span class="ident">works</span> <span class="op">=</span> <span class="ident">panic::catch_unwind</span>(<span class="ident">proc_macro::Span::call_site</span>).<span class="ident">is_ok</span>();
    <span class="ident">WORKS</span>.<span class="ident">store</span>(<span class="ident">works</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">+</span> <span class="number">1</span>, <span class="ident">Ordering::Relaxed</span>);

    <span class="kw">let</span> <span class="ident">hopefully_null_hook</span> <span class="op">=</span> <span class="ident">panic::take_hook</span>();
    <span class="ident">panic::set_hook</span>(<span class="ident">original_hook</span>);
    <span class="kw">if</span> <span class="ident">sanity_check</span> <span class="op">!</span><span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="ident">hopefully_null_hook</span> {
        <span class="macro">panic!</span>(<span class="string">&quot;observed race condition in proc_macro2::inside_proc_macro&quot;</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="proc_macro2" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>